#version 150

#moj_import <fog.glsl>
#moj_import <shader_utils.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec4 lightMapColor;
in vec4 overlayColor;
in vec2 texCoord0;

out vec4 fragColor;

void main() {
    float alpha = texture(Sampler0, texCoord0).a * 255.0;
    vec4 color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator * lightMapColor;

    if(alpha == 254){
        color = texture(Sampler0, texCoord0);
    }

    if(alpha == 253){
        color = texture(Sampler0, texCoord0) * vec4(0.8, 0.8, 0.8, 1);
    }

    if(alpha == 252){
        discard;
    }

    if(alpha == 0){
        discard;
    }

    color.rgb = mix(vec3(0.5, 0.5, 0.5), color.rgb, overlayColor.a);

    fragColor = linear_fog(getFixedBlueWhiteColor(color, texture(Sampler0, texCoord0)), vertexDistance, FogStart, FogEnd, FogColor);
}
